import { defineComponent as j, watch as q, ref as g, onMounted as K, openBlock as d, createElementBlock as p, normalizeClass as h, Fragment as v, renderList as T, withDirectives as E, createElementVNode as C, normalizeStyle as M, withModifiers as z, vModelDynamic as A, toDisplayString as H, createCommentVNode as O } from "vue";
const U = ["element-num", "id", "onUpdate:modelValue", "type", "disabled", "readonly", "onKeyup", "onPaste", "onFocus", "autocomplete"], L = {
  key: 0,
  class: "hl-separator"
}, G = /* @__PURE__ */ j({
  __name: "HOtpInput",
  props: {
    length: {
      type: Number,
      required: !0,
      default: 6
    },
    defaultColor: {
      type: String,
      default: "#eeeeee"
    },
    mainColor: {
      type: String,
      default: "#00dc82",
      required: !1
    },
    fontColor: {
      type: String,
      default: "black",
      required: !1
    },
    allowPaste: {
      type: Boolean,
      default: !0,
      required: !1
    },
    onlyNumber: {
      type: Boolean,
      default: !1
    },
    isRefresh: {
      type: Boolean,
      default: !1
    },
    type: {
      type: String,
      default: "password",
      validator: (l) => ["password", "text"].includes(l)
    },
    autoFocus: {
      type: Boolean,
      default: !0
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    outlined: {
      type: Boolean,
      default: !1
    },
    readonly: {
      type: Boolean,
      default: !1
    },
    wrapperClassName: {
      type: String,
      default: ""
    },
    inputClassName: {
      type: String,
      default: ""
    },
    autocomplete: {
      type: [String],
      default: "off"
    },
    separator: {
      type: String,
      default: ""
    },
    separatorType: {
      type: String,
      default: "middle",
      validator: (l) => ["middle", "all"].includes(l)
    }
  },
  emits: ["onFinish", "onChange"],
  setup(l, { expose: b, emit: f }) {
    const o = l;
    q(
      () => o.isRefresh,
      () => {
        a.value = [], r[0].focus(), s.value = -1;
      }
    );
    const S = (e) => o.separatorType === "middle" ? e === o.length / 2 - 1 : e < o.length - 1, r = {}, a = g([]), s = g(-1), w = () => {
      a.value = [], r[0].focus(), s.value = -1;
    }, B = (e) => {
      if (!o.onlyNumber)
        return;
      const t = e.charCode || e.keyCode || 0;
      t === 8 || t === 46 || t === 86 || t === 91 || t >= 48 && t <= 57 || t >= 96 && t <= 105 || e.preventDefault();
    }, F = (e, t) => {
      r[e] = t;
    }, N = (e) => `hl-${e + 1}`, m = (e) => `3px solid ${a.value[e] ? o.mainColor : o.defaultColor}`, V = (e) => {
      a.value[e] && a.value[e] !== "" && e < o.length ? (s.value = e + 1, r[e + 1] && r[e + 1].focus()) : e > 0 && (!a.value[e] || a.value[e] === "") && r[e - 1] && (r[e - 1].focus(), s.value = e - 1);
    }, k = (e) => {
      r[e].select();
    }, I = (e) => {
      var t;
      if (o.allowPaste) {
        const c = ((t = e == null ? void 0 : e.clipboardData) == null ? void 0 : t.getData("text/plain")) || "", n = c.split("");
        let u = !0;
        if (o.onlyNumber && (u = new RegExp(`^\\d{${o.length}}$`).test(c)), u) {
          for (let i = 0; i < o.length; i++)
            $(i, n[i]);
          r[o.length - 1].focus(), y();
        }
      }
    }, $ = (e, t) => {
      a.value[e] = t;
    }, y = () => {
      const e = a.value.join("");
      f("onChange", e), e.length === o.length && (f("onFinish", e), s.value = -1);
    }, R = () => {
      const e = a.value.join("");
      if (!o.separator)
        return e;
      if (o.separatorType === "middle") {
        const t = e.split("");
        return t.splice(o.length / 2, 0, o.separator), t.join("");
      } else
        return e.split("").join(o.separator);
    };
    K(() => {
      o.autoFocus && r && r[0].focus();
    });
    const D = (e) => o.outlined ? {
      outline: P(s.value === e),
      borderBottom: "none",
      borderRadius: "2px"
    } : {
      borderBottom: m(e)
    }, P = (e) => {
      const t = e ? o.mainColor : o.defaultColor;
      return o.outlined ? `2px solid ${t}` : "none";
    };
    return b({
      clear: w,
      genResultWithSeparator: R
    }), (e, t) => (d(), p("div", {
      class: h(["hl-input-container m-auto text-center", l.wrapperClassName])
    }, [
      (d(!0), p(v, null, T(l.length, (c, n) => (d(), p(v, { key: n }, [
        E(C("input", {
          "element-num": c,
          id: N(n),
          ref_for: !0,
          ref: (u) => F(n, u),
          "onUpdate:modelValue": (u) => a.value[n] = u,
          type: l.type,
          maxlength: "1",
          style: M({
            borderBottom: m(n),
            color: l.fontColor,
            ...D(n)
          }),
          class: h(l.inputClassName),
          disabled: l.disabled,
          readonly: l.readonly,
          contenteditable: "true",
          onKeydown: t[0] || (t[0] = (u) => B(u)),
          onKeyup: (u) => V(n),
          onPaste: z(I, ["prevent"]),
          onInput: t[1] || (t[1] = (u) => y()),
          onFocus: (u) => k(n),
          autocomplete: l.autocomplete
        }, null, 46, U), [
          [A, a.value[n]]
        ]),
        l.separator && S(n) ? (d(), p("div", L, [
          C("span", null, H(l.separator), 1)
        ])) : O("", !0)
      ], 64))), 128))
    ], 2));
  }
});
export {
  G as HOtpInput
};
